summaryrefslogtreecommitdiff
path: root/tests/misc/wc-files0
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>2006-06-25 18:26:09 +0000
committerJim Meyering <jim@meyering.net>2006-06-25 18:26:09 +0000
commitcc705714016dae0b64e50f535f8c2db284a83f80 (patch)
treed49898d58951ebcef2d4969be7d65ef2a5f49dd7 /tests/misc/wc-files0
parentb2657ecc6a8193a862991bfb08cdc91c6cc5cb91 (diff)
downloadcoreutils-cc705714016dae0b64e50f535f8c2db284a83f80.tar.xz
* NEWS: wc accepts a new option --files0-from=FILE, where FILE
contains a list of NUL-separated file names. * src/wc.c: Include "readtokens.h". (usage): Describe the new option, and adjust the `Usage': with this option, no FILE may be specified on the command line. (main): Handle the new option. * tests/misc/wc-files0: New tests, for the above. * tests/misc/wc-files0-from: Likewise. * tests/misc/Makefile.am (TESTS): Add wc-files0.
Diffstat (limited to 'tests/misc/wc-files0')
-rwxr-xr-xtests/misc/wc-files049
1 files changed, 49 insertions, 0 deletions
diff --git a/tests/misc/wc-files0 b/tests/misc/wc-files0
new file mode 100755
index 000000000..8041359c8
--- /dev/null
+++ b/tests/misc/wc-files0
@@ -0,0 +1,49 @@
+#!/bin/sh
+# Show that wc's new --files0-from option works.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ wc --version
+fi
+
+. $srcdir/../lang-default
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd $pwd; chmod -R u+rwx $t0; rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+
+echo 2 > 2b || framework_failure=1
+echo 2 words > 2w || framework_failure=1
+printf '2b\n2w\n' |tr '\n' '\0' > names || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+wc --files0-from=names > out || fail=1
+cat <<\EOF > exp || fail=1
+ 1 1 2 2b
+ 1 2 8 2w
+ 2 3 10 total
+EOF
+
+cmp out exp || fail=1
+test $fail = 1 && diff out exp 2> /dev/null
+
+if test "$fail" = ''; then
+ # Repeat the above test, but read the file name list from stdin.
+ rm -f out
+ wc --files0-from=- < names > out || fail=1
+ cmp out exp || fail=1
+ test $fail = 1 && diff out exp 2> /dev/null
+fi
+
+(exit $fail); exit $fail